<template>
  <div>
    <div class="form-box">
      <el-form :model="formData" ref="elFormRef" label-position="right" :rules="rule" label-width="80px">
        <el-form-item label="语言类型 1中文 2英文:" prop="langType">
          <el-input v-model.number="formData.langType" :clearable="true" placeholder="请输入" />
       </el-form-item>
        <el-form-item label="商品主图:" prop="goodsMainPic">
          <el-input v-model="formData.goodsMainPic" :clearable="true" placeholder="请输入" />
       </el-form-item>
        <el-form-item label="商品名称:" prop="name">
          <el-input v-model="formData.name" :clearable="true" placeholder="请输入" />
       </el-form-item>
        <el-form-item label="简介:" prop="briefIntroduction">
          <el-input v-model="formData.briefIntroduction" :clearable="true" placeholder="请输入" />
       </el-form-item>
        <el-form-item label="类型:" prop="type">
          <el-input v-model.number="formData.type" :clearable="true" placeholder="请输入" />
       </el-form-item>
        <el-form-item label="主介绍:" prop="mainIntroduction">
          <el-input v-model="formData.mainIntroduction" :clearable="true" placeholder="请输入" />
       </el-form-item>
        <el-form-item label="商品副图:" prop="goodsAssistantPic">
          <el-input v-model="formData.goodsAssistantPic" :clearable="true" placeholder="请输入" />
       </el-form-item>
        <el-form-item label="副介绍标题:" prop="secondIntroductionTitle">
          <el-input v-model="formData.secondIntroductionTitle" :clearable="true" placeholder="请输入" />
       </el-form-item>
        <el-form-item label="副介绍,逗号拼接:" prop="secondIntroduction">
          <el-input v-model="formData.secondIntroduction" :clearable="true" placeholder="请输入" />
       </el-form-item>
        <el-form-item>
          <el-button type="primary" @click="save">保存</el-button>
          <el-button type="primary" @click="back">返回</el-button>
        </el-form-item>
      </el-form>
    </div>
  </div>
</template>

<script setup>
import {
  createGoodsShow,
  updateGoodsShow,
  findGoodsShow
} from '@/api/goodsShow'

defineOptions({
    name: 'GoodsShowForm'
})

// 自动获取字典
import { getDictFunc } from '@/utils/format'
import { useRoute, useRouter } from "vue-router"
import { ElMessage } from 'element-plus'
import { ref, reactive } from 'vue'

const route = useRoute()
const router = useRouter()

const type = ref('')
const formData = ref({
            langType: 0,
            goodsMainPic: '',
            name: '',
            briefIntroduction: '',
            type: 0,
            mainIntroduction: '',
            goodsAssistantPic: '',
            secondIntroductionTitle: '',
            secondIntroduction: '',
        })
// 验证规则
const rule = reactive({
               langType : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               name : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               type : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
})

const elFormRef = ref()

// 初始化方法
const init = async () => {
 // 建议通过url传参获取目标数据ID 调用 find方法进行查询数据操作 从而决定本页面是create还是update 以下为id作为url参数示例
    if (route.query.id) {
      const res = await findGoodsShow({ ID: route.query.id })
      if (res.code === 0) {
        formData.value = res.data.regoodsShow
        type.value = 'update'
      }
    } else {
      type.value = 'create'
    }
}

init()
// 保存按钮
const save = async() => {
      elFormRef.value?.validate( async (valid) => {
         if (!valid) return
            let res
           switch (type.value) {
             case 'create':
               res = await createGoodsShow(formData.value)
               break
             case 'update':
               res = await updateGoodsShow(formData.value)
               break
             default:
               res = await createGoodsShow(formData.value)
               break
           }
           if (res.code === 0) {
             ElMessage({
               type: 'success',
               message: '创建/更改成功'
             })
           }
       })
}

// 返回按钮
const back = () => {
    router.go(-1)
}

</script>

<style>
</style>
